/* {{{ Copyright etc. */

/*  avw2ascii.c - convert AVW to raw ASCII text

    Stephen Smith, FMRIB Image Analysis Group

    Copyright (C) 2001 University of Oxford  */

/*  CCOPYRIGHT */

/* }}} */
/* {{{ defines, includes and typedefs */

#include "libss/libss.h"
#include "libss/libavw.h"

void usage(void);

/* }}} */
/* {{{ usage */

void usage(void)
{
  printf("\nUsage: avw2ascii <input> <output>\n\n");
  exit(1);
}

/* }}} */
/* {{{ main */

int main(argc,argv) 
     int argc;
     char **argv;
{
  image_struct im;
  int x,y,z,t;

  /* {{{ process args and read input */

if (argc<3)
     usage();

avw_read(argv[1],&im);

im.t=MAX(im.t,1);

/* }}} */
  /* {{{ process roi and output */

for(t=0;t<im.t;t++)
{
  FILE *ofp;
  char filename[1000];

  sprintf(filename,"%s%05d",argv[2],t);
  ofp=fopen(filename,"wb");

  for(z=0;z<im.z;z++)
    {
      for(y=0;y<im.y;y++)
	{
	  for(x=0;x<im.x;x++)
	    {
	      if (im.dt<DT_FLOAT)
		fprintf(ofp,"%d ",(int)  im.i[t*im.z*im.y*im.x + z*im.y*im.x + y*im.x + x]);
	      else
		fprintf(ofp,"%f ",(float)im.i[t*im.z*im.y*im.x + z*im.y*im.x + y*im.x + x]);
	    }
	  fprintf(ofp,"\n");
	}
      fprintf(ofp,"\n");
    }

  fclose(ofp);
}

/* }}} */

  exit(0);
}

/* }}} */
