/* $Id: writeavw.c,v 1.5 2003/02/22 18:38:46 mark Exp $ */
#include <stdlib.h>
#include "avwimage.h"
#include "imutils.h"

void WriteAVW(const char *filename, AVWImage *im)
{
  AVW *avw = AvwOpen(filename, "w");

				/* Copy in im's dsr header */
  memcpy(&avw->header, im->header, sizeof(struct dsr));

  AvwSetDataType(avw, im->dt);

  AvwSetDim(avw, im->xdim, im->ydim, im->zdim, im->vdim);
  AvwSetDimensionality(avw, 4);
  AvwSetVoxDim(avw, im->xvox, im->yvox, im->zvox, im->tr);
  AvwSetMinMax(avw, im->min, im->max);

  avw->header.hist.orient = im->orient;

  memcpy(avw->header.hk.db_name, im->study, 18);
  memcpy(avw->header.hist.descrip, im->descrip, 80);
  memcpy(avw->header.hist.scannum, im->scannum, 10);
  memcpy(avw->header.hist.exp_date, im->date, 10);
  memcpy(avw->header.hist.patient_id, im->patient, 10);

  {
    short short_array[3];
    short_array[0]=im->xo;
    short_array[1]=im->yo;
    short_array[2]=im->zo;
    memcpy(avw->header.hist.originator,short_array,3*sizeof(short));
  }

  switch(im->orient)
    {
    case AVWIM_AXIAL:                         break;
    case AVWIM_SAGITTAL: reorder(im, ax2sag); break;
    case AVWIM_CORONAL:  reorder(im, cor2ax); break;
    default: break;
    }

  AvwWriteVolumes(avw, im->data, im->vdim);

  AvwClose(avw);
}
