
/*  libssbase.h - basic C include stuff

    Stephen Smith, FMRIB Image Analysis Group

    Copyright (C) 1999-2000 University of Oxford  */

/*  CCOPYRIGHT */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <ctype.h>
#include <limits.h>
#include <sys/types.h>
#include <sys/stat.h>

#ifndef FDT
#define FDT unsigned char
#endif

/* some weird stuff to expand the data type into a string */
#define FDTSSS(s) #s
#define FDTSS(s) FDTSSS(s)
#define FDTS FDTSS(FDT)

#ifndef MAX
#define MAX(a,b)   ( (a) > (b) ? (a) : (b) )
#endif

#ifndef MIN
#define MIN(a,b)   ( (a) < (b) ? (a) : (b) )
#endif

#define SGN(a)  ( (a) > 0   ? (1) : (-1) )
#define FTOI(a) ( (a) < 0 ? ((int)(a-0.5)) : ((int)(a+0.5)) )
#define ABS(a)  ( (a) > 0   ? (a) : (-(a)) )

/* a cheap and grotty way of indexing 3/4D data - sometimes useful */
#define IA(i,x,y,z)   ( i[((z)*y_size+(y))*x_size+(x)] )
#define IT(i,x,y,z,t) ( i[(((t)*z_size+(z))*y_size+(y))*x_size+(x)] )

#if !defined(M_PI)
# define M_PI 3.14159265358979323846
#endif
