/*  displacement.cc - Artificial Motion Generator
    
    Peter Bannister, FMRIB Image Analysis Group
    
    Copyright (C) 1999-2000 University of Oxford  */

/*  CCOPYRIGHT */


#include <math.h>
#include <iostream.h>
#include <fstream.h>
#include <iomanip>
#include <stdlib.h>
#include <stdio.h>
#include <string>
#include <strstream>

#include "newimage/newimageall.h"
#include "newimage/costfns.h"
#include "newmatap.h"

#include "Globaloptions.h"
#include "Log.h"

using namespace MISCMATHS;
using namespace NEWMAT;
using namespace NEWIMAGE;
using namespace UTILS;

int main (int argc,char** argv){
  
  volume4D<float> epi;
  volume<float> save(64,64,21);

  Matrix aff(4,4);
  Log& logger = Log::getInstance();

  string outputfname;
  string inputfname, matdirname;


  if (argc < 3){
    cerr << "Usage: nullmotion <input_timeseries> <transformation_mats_dir>" << endl;
    exit(1);
  }

  inputfname = argv[1];
  matdirname = argv[2];
  
  logger.setDir(matdirname);

  cerr << "Reading stationary time series" << inputfname << " ... " << endl;
  volumeinfo vinfo;
  read_volume4D(epi, inputfname, vinfo);
  save. setdims(4,4,6);
 
  save.setextrapolationmethod(extraslice);
  save.setinterpolationmethod(trilinear);

  for (int i = 0; i < epi.tdim(); i++){ 
    char strc[50];
    ostrstream osc(strc,50);
    osc << "MAT_0" << setw(3) << setfill('0') << i << '\0';
    cerr << "Applying matrix: " << strc << endl;
    logger. in(strc, aff,4,4);
    cerr << "read in matrix" << endl;
    cerr << aff << endl;
    affine_transform(save, epi[i], aff);
    cerr << "transform applied ... " << endl;
    epi[i] = save;
  }
  save_volume4D_dtype(epi, inputfname + "_mcf", dtype(inputfname), vinfo);
}








