#include <math.h>
#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include <stdio.h>
#include <string>

#include "newimage/newimageall.h"
#include "newmatap.h"

#include "Globaloptions.h"

using namespace MISCMATHS;
using namespace NEWMAT;
using namespace NEWIMAGE;

//------------------------------------------------------------------------//


int main (int argc,char** argv)
{
  volume4D<float> timeseries;
  volume<float> refvol, anisorefvol, variancevol, meanvol, sigmavol;
  int vmax;
  Globaloptions& globalopts = Globaloptions::getInstance();
  

  cerr << endl << "vmapper v 0.1.1" << endl <<"This software is currently alpha." << endl << "Please send any comments/ queries to: prb@fmrib.ox.ac.uk" << endl << endl;
  globalopts.parse_command_line(argc, argv);
  cerr << "Reading time series... " << endl;
  volumeinfo vinfo;
  read_volume4D(timeseries, globalopts.inputfname, vinfo);
  vmax = timeseries.tsize();
  
  meanvol = timeseries[0];
  variancevol = timeseries[0];
  sigmavol = timeseries[0];
  
  meanvol = 0.0;
  variancevol = 0.0;
  sigmavol = 0.0;

  cerr << "This version has been hacked for AIR/ SPM corrected data." << endl  
       << "The end slices are ignored when calculating mean and variance statistics" << endl;

  // calculate the mean value and variance at each voxel
  for (int x=0; x< timeseries[0].xsize(); x++) {
    for (int y=0; y< timeseries[0].ysize(); y++) {
      for (int z=1; z< (timeseries[0].zsize()-1); z++) {
	for (int i=0; i< vmax; i++) 
	  meanvol(x,y,z) += timeseries[i](x,y,z);
	meanvol(x,y,z) = meanvol(x,y,z)/(float)vmax;
	}
    }
  }

  cerr << "generated mean image" << endl;

  // change limits on z index for end slice exclusion
  for (int x=0; x< timeseries[0].xsize(); x++) {
    for (int y=0; y< timeseries[0].ysize(); y++) {
      for (int z=1; z< (timeseries[0].zsize()-1); z++) {
	for (int i=0; i< vmax; i++)
	  variancevol(x,y,z) += (timeseries[i](x,y,z) - meanvol(x,y,z))*(timeseries[i](x,y,z) - meanvol(x,y,z));
	variancevol(x,y,z) = variancevol(x,y,z)/((float)(vmax - 1));
	sigmavol(x,y,z) = sqrt(variancevol(x,y,z));
      }
    }
  }
  
  cerr << "Saving mean volume... " << endl;
  save_volume_dtype(meanvol, "mean_"+globalopts.inputfname, dtype(globalopts.inputfname), vinfo);

  cerr << "Saving variance volume... " << endl;
  save_volume_dtype(variancevol, "variance_"+globalopts.inputfname, dtype(globalopts.inputfname), vinfo);

  cerr << "Saving standard deviation volume... " << endl;
  save_volume_dtype(sigmavol, "sigma_"+globalopts.inputfname, dtype(globalopts.inputfname), vinfo);
}








