/* {{{ copyright */

/*  ztop - convert a single z value into p

    Stephen Smith, FMRIB Image Analysis Group

    Copyright (C) 2002 University of Oxford  */

/*  CCOPYRIGHT */

/* }}} */
/* {{{ defines */

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "libprob.h"

#define MINP 1e-15

using namespace MISCMATHS;

/* }}} */
/* {{{ usage */

void usage(void)
{
  printf("Usage: ztop <p> [-2]\n");
  printf("-2 : use 2-tailed conversion (default is 1-tailed)\n");
  exit(1);
}

/* }}} */

int main(int argc,char *argv[])
{
  int i, twotailed=0;
  double p, z;

  if (argc<2)
    usage();

  z=atof(argv[1]);

  /* {{{ process args */

for (i=2; i<argc; i++)
{
  if (!strcmp(argv[i], "-2"))
    twotailed=1;

  else
    usage();
}

/* }}} */

  p=1-ndtr(z);

  if (twotailed)
    p*=2;
  
  if (p>0.0001) 
    printf("%f\n",p);
  else
    printf("%e\n",p);

  return(0);
}
