#

#   group_do - generic group operation from a script
#
#   Stephen Smith, FMRIB Image Analysis Group
#
#   Copyright (C) 1999-2000 University of Oxford
#
#   TCLCOPYRIGHT

if { [ info exists env(FSLDIR) ] } {
    set FSLDIR $env(FSLDIR)
} else {
    set FSLDIR $PXHOME/fsl
}

source ${FSLDIR}/tcl/medxstart.tcl
set auto_path [ linsert $auto_path 0 [ file dirname [ info script ] ] ]

MxGetCurrentFolder Folder
MxGetCurrentGroup Group

set filename /tmp/${USER}_group_do.tcl
set channel [open $filename "w"]

puts $channel {#
MxGetCurrentFolder Folder
MxGetCurrentGroup Group
MxGetPagesFromGroup $Group Pages
foreach Page $Pages {
  MxSetCurrentPage $Page
  puts $Page

  # put a page command on the following line, e.g.: MxThreshold $Page 100 V

}

# examples:

# group set properties:
#MxSetScale $Page 3.438 3.438 8.0
#MxSetImageProperties $Page {{DistanceUnits "mm"}}

# group save files individually:
#set outputdir /tmp/${USER}OUTPUTFILES
#exec /bin/mkdir $outputdir
#set i 0
#foreach Page $Pages {
#puts $Page
#set pad [format %04d $i]
#FSLSaveAs $Page AVW $outputdir/vol$pad.hdr true
#incr i 1
#}

# group SUSAN
#MxSetCurrentPage $Page
#set susan_dim 3D
#set susan_bt 50
#set susan_dt 10
#source ${PXHOME}/fmrib/src/susan/susan.tcl

}
close $channel

exec sh $PXHOME/bin/editconv.sh $filename $filename &
MxPause "Edit the file in the editor (use ImageScript Logging to find out what to put into the editor). Then save the file, kill the editor and press OK."

source $filename
