#

#   print_gif - output tiff image and convert to gif
#
#   Stephen Smith, FMRIB Image Analysis Group
#
#   Copyright (C) 1999-2000 University of Oxford
#
#   TCLCOPYRIGHT

proc print_gif { thefile } {

    global FSLDIR

    keylset PrinterProps Type Tiff
    keylset PrinterProps Orientation Landscape
    keylset PrinterProps NumCopies 1
    keylset PrinterProps Name ${thefile}.tif
    MxSetPrinterSetup PrinterProps

    MxGetCurrentPage thepage
    puts $thepage
    MxGetImageProperties $thepage thepageprops
    keylset thepageprops CaptionColor 0
    MxSetImageProperties $thepage thepageprops
    MxPrintPage $thepage

    after 5000
    
    set errrr [ catch { exec ${FSLDIR}/bin/convert -colors 100 -crop 0x0 ${thefile}.tif ${thefile}.gif } junk ]
    if { $errrr == 0 } {
	set errrr [ catch { exec /bin/rm -f ${thefile}.tif } junk ]
	set errrr [ catch { exec /bin/rm -f ${thefile}.tif } junk ]
	set errrr [ catch { exec /bin/rm -f ${thefile}.tif } junk ]
    }
}
