#

#   iso - this changes the voxel size to make the image isotropic
#
#   Stephen Smith, FMRIB Image Analysis Group
#
#   Copyright (C) 1999-2000 University of Oxford
#
#   TCLCOPYRIGHT

if { [ info exists env(FSLDIR) ] } {
    set FSLDIR $env(FSLDIR)
} else {
    set FSLDIR $PXHOME/fsl
}

source ${FSLDIR}/tcl/medxstart.tcl
set auto_path [ linsert $auto_path 0 [ file dirname [ info script ] ] ]

MxGetCurrentFolder Folder

MxGetFolderProperties $Folder FolderProps

set FolderName [ keylget FolderProps Name ]
set FolderFile [ keylget FolderProps File ]
set FolderDirFile [ file dirname $FolderFile ]
set FolderTailFile [ file tail $FolderFile ]
set FolderExtension [ file extension $FolderFile ]

set IsTmp [ string compare /tmp [ string range $FolderDirFile 0 3 ] ]
if { ! [ file writable "${FolderDirFile}" ] || $IsTmp == 0 } {
    set FolderDirFile "/usr/people/${USER}"
}

set IsFld [ string compare .fld [ string range $FolderExtension 0 3 ] ]
if { $IsFld != 0 } {
    set FolderTailFile ${PROCID}.fld
}

MxSetFolderProperties $Folder "{File ${FolderDirFile}/${FolderTailFile}}"

set Continue [YesNoWidget "The folder will be saved to ${FolderDirFile}/${FolderTailFile} - is this OK?" "Yes" "No"]

if { ! $Continue } {
    MxPause "Change the folder file name in folder properties and then rerun this script"
    MxDialogFolderProperties 0
    exit
}

global Delay
set Delay 1.0
InputFromWidget "Delay" 1 "Enter delay in hours before saving folder" Delay 6

set Die [YesNoWidget "Do you want to kill MEDx after saving the folder?" "Yes" "No"]

after [ expr int( $Delay * 60.0 * 60.0 * 1000.0 ) ]

MxSaveFolder $Folder

if { $Die } {
    MxExitMEDx
}
