#

#   volume_or_image_run - check current page is a volume or 2D image and run a script
#
#   Stephen Smith, FMRIB Image Analysis Group
#
#   Copyright (C) 1999-2000 University of Oxford
#
#   TCLCOPYRIGHT

global TheFile
global TheCommand
global TheArgs

set error [MxGetCurrentFolder Folder]
if {$error == 1} {
  puts "You don't have an open folder!"
  MxPause "You don't have an open folder!"
} else {

set error [MxGetCurrentPage Page]
if {$error != 0} {
  puts "You aren't viewing an image or a volume image in the current folder!"
  MxPause "You aren't viewing an image or a volume in the current folder!"
} else {

MxGetPageProperties $Page Props
set PageType [keylget Props Type]
if {[string match $PageType Volume] != 1 && [string match $PageType Image] != 1} {
  puts "You aren't viewing an image or a volume in the current folder!"
  MxPause "You aren't viewing an image or a volume in the current folder!"
} else {

MxGetCurrentImage Image
source $TheFile
if {$TheCommand != "dummycommand"} {
$TheCommand $Folder $Image $TheArgs
}   }   }   }
