/* {{{ Copyright etc. */

/*  scatter - scatterplot from two images

    Stephen Smith, FMRIB Image Analysis Group

    Copyright (C) 1999-2001 University of Oxford  */

/*  CCOPYRIGHT */

/* }}} */
/* {{{ defines, includes and typedefs */

#include "libss/libss.h"
#include "libss/libavw.h"

/* }}} */
/* {{{ main(argc, argv) */

int main(argc, argv)
  int   argc;
  char  *argv [];
{
/* {{{ vars */

FDT    *in;
int    n_vols, i, tmp, x_size, y_size, z_size, x, y, z;
double *values;
FILE   *ofp;
image_struct im;

/* }}} */

  /* {{{ process arguments */

avw_read(argv[1],&im);

in=im.i; x_size=im.x; y_size=im.y; z_size=im.z; n_vols=im.t;

values = (double*)malloc(sizeof(double)*n_vols);

ofp=fopen(argv[2],"wb");

/* }}} */
  /* {{{ main stuff */

  for (z=0; z<z_size; z++)
    for (y=0; y<y_size; y++)
      for (x=0; x<x_size; x++)
      {
        tmp=0;
        for(i=0; i<n_vols; i++)
	{
          values[i]=in[i*z_size*y_size*x_size+z*y_size*x_size+y*x_size+x];
          if (values[i]!=0)
            tmp=1;
	}
        if (tmp)
	{
          for(i=0; i<n_vols; i++)
            fprintf(ofp,"%f ",values[i]);
          fprintf(ofp,"\n");
	}
      }

/* }}} */

  return(0);
}

/* }}} */
