#

#   scatter - creat scatter plot from two images
#
#   Stephen Smith, FMRIB Image Analysis Group
#
#   Copyright (C) 1999-2000 University of Oxford
#
#   TCLCOPYRIGHT


if { [ info exists env(FSLDIR) ] } {
    set FSLDIR $env(FSLDIR)
} else {
    set FSLDIR $PXHOME/fsl
}

source ${FSLDIR}/tcl/medxstart.tcl
set auto_path [ linsert $auto_path 0 [ file dirname [ info script ] ] ]

proc show_graph { Filename } {

    set count 0
    set w ".dialog[incr count]"
    while { [ winfo exists $w ] } {
        set w ".dialog[incr count]"
    }

    toplevel $w
    wm title $w "Scatter Plot"
    wm iconname $w "Plot"

    frame $w.f

    label $w.f.label
    pack $w.f.label -in $w.f
    pack $w.f

    set graphpic [image create photo -file $Filename ]
    $w.f.label configure -image $graphpic
}

proc scatter {Folder Group dummy} {

    global FSLDIR

MxGetPagesFromGroup $Group Pages
puts $Pages

MxGetImageProperties [ lindex $Pages 0 ] props

if { [ keylget props Slices ] == 0 } {
    puts "Will have to force these to be volumes..."
    set thelist ""
    foreach Page $Pages {
	MxComposeVolume { $Page } V
	lappend thelist $V
    }
    MxGroupVolumes { $thelist } "Group of Vols" Group
    MxGetPagesFromGroup $Group Pages
    puts $Pages
}

set TN [ exec sh -c "${FSLDIR}/bin/tmpnam /tmp/sc" ]

FSLSaveAs $Group AVW ${TN}.hdr true 

set thecommand "${FSLDIR}/bin/scatter $TN ${TN}.txt"
puts $thecommand
ScriptUpdate "Calling $thecommand"
set result [catch { exec sh -c $thecommand} ErrMsg]

if {$result != 0} {
  puts "$ErrMsg"
}

MxSetCurrentPage $Group
CancelScriptUpdate
ScriptUpdate "Running gnuplot"

set gpid [ open "| ${FSLDIR}/bin/gnuplot > ${TN}.ppm" "w" ]
            puts $gpid "set term pbm small color"
            puts $gpid "plot \'${TN}.txt\' title 'image1 vs image0' with dots , x notitle with lines"
            close $gpid
show_graph ${TN}.ppm

exec sh -c "rm -f ${TN}*"

CancelScriptUpdate
MxPause ""
}
