#include "options.h"

// $Id: usage.cc,v 1.4 2001/05/11 17:40:17 beckmann Exp $

namespace Utilities {

  void OptionParser::usage()
  {
    cerr << endl << progname_ << endl << endl;
    cerr << "Usage: " << endl << example_ << endl;

    for(Options::iterator option = options_.begin(); option != options_.end(); 
	option++)
      {
	if((*option)->compulsory() && (*option)->visible()) {
	  static bool banner = true;
	  if(banner) {
	    cerr << endl << "Compulsory arguments (You MUST set one or more of):" << endl;
	    banner = false;
	  }
	  cerr << **option << endl;
	}
      }


    for(Options::iterator option = options_.begin(); option != options_.end(); 
	option++)
      {
	if(!(*option)->compulsory() && (*option)->visible()) {
	  static bool banner = true;
	  if(banner) {
	    cerr << endl << "Optional arguments (You may optionally specify one or more of):" << endl;
	    banner = false;
	  }
	  cerr << **option << endl;
	}
      }

    cerr << endl;
    cerr << endl;
  }

}
